# -*- python -*-
# $RCSfile: pixelselectionmenu.py,v $
# $Revision: 1.5 $
# $Author: haan $
# $Date: 2004/02/18 02:48:30 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from SWIG.common import switchboard
from common import debug
from common import microstructure
from common import pixelselectionmod
from common import utils
from common.IO import mainmenu
from common.IO import oofmenu
from common.IO import whoville

selmodmenu = mainmenu.OOF.addItem(oofmenu.OOFMenuItem('PixelSelection',
                                                      cli_only=1))

def buildSelectionModMenu():
    selmodmenu.clearMenu()
    selmodmenu.addItem(oofmenu.OOFMenuItem(
        'Undo',
        params=[whoville.WhoParameter('selectable',
                                      microstructure.microStructures)],
        callback=pixelselectionmod.undo))
    selmodmenu.addItem(oofmenu.OOFMenuItem(
        'Redo',
        params=[whoville.WhoParameter('selectable',
                                      microstructure.microStructures)],
        callback=pixelselectionmod.redo))

    selmodmenu.addItem(oofmenu.OOFMenuItem(
        'Clear',
        params=[whoville.WhoParameter('selectable',
                                      microstructure.microStructures)],
        callback=pixelselectionmod.clear))
    for registration in pixelselectionmod.SelectionModifier.registry:
        menuitem = selmodmenu.addItem(
            oofmenu.OOFMenuItem(utils.space2underscore(registration.name()),
                                callback=pixelselectionmod.doSelectionMod,
                                threadable=oofmenu.THREADABLE,
                                params=[
            whoville.WhoParameter('selectable', microstructure.microStructures)
            ]+registration.params))
        menuitem.data = registration
    
# Rebuild the selection modification menu whenever a new
# SelectionModifier Registration is created.  Hopefully this won't be
# too often.

switchboard.requestCallback(pixelselectionmod.SelectionModifier,
                            buildSelectionModMenu)


buildSelectionModMenu()
