# -*- python -*-
# $RCSfile: threadmanagermenu.py,v $
# $Revision: 1.8 $
# $Author: redwing $
# $Date: 2004/07/13 17:54:12 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 



from common.IO import mainmenu
from common.IO import parameter
from common.IO import progressbar_delay
from common.IO.oofmenu import OOFMenuItem, CheckOOFMenuItem
from common.IO.threadmanager import threadManager

FloatParameter = parameter.FloatParameter

threadmanagermenu = mainmenu.OOF.addItem(OOFMenuItem('ActivityViewer', secret=1))
filemenu = threadmanagermenu.addItem(OOFMenuItem('File'))
filemenu.addItem(OOFMenuItem('Close', callback=threadManager.close, no_log=1, accel='w'))

settingsmenu = threadmanagermenu.addItem(OOFMenuItem('Settings'))
settingsmenu.addItem(CheckOOFMenuItem('AutoDismiss', value=threadManager.AutoDismiss,
                                      callback=threadManager.disableAutoDismiss,
                                      help="Dismiss progress bars automatically when processes end."))

settingsmenu.addItem(OOFMenuItem('DelayProgressBarCreation', callback=progressbar_delay.set_delay,
                                 params=[
    FloatParameter('milliseconds', progressbar_delay._snooze)],
                                 help='Create progress bars only for processes that take longer than the specified number of milliseconds.'))




