# -*- python -*-
# $RCSfile: colordifference_.py,v $
# $Revision: 1.3 $
# $Author: langer $
# $Date: 2004/09/07 15:17:00 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from common import cregisteredclass
from common.IO import parameter

cregisteredclass.registerCClass(ColorDifferencePtr)

FloatRangeParameter = parameter.FloatRangeParameter

deltargb = cregisteredclass.Registration(
    "DeltaRGB", ColorDifferencePtr, DeltaRGB, ordering=1,
    params=[
    FloatRangeParameter('delta_red', (0.0, 1.0, 0.01), 0.0),
    FloatRangeParameter('delta_green', (0.0, 1.0, 0.01), 0.0),
    FloatRangeParameter('delta_blue', (0.0, 1.0, 0.01), 0.0)],
    tip="Range of colors in red, green, and blue space.")

cregisteredclass.Registration(
    'DeltaGray', ColorDifferencePtr, DeltaGray, ordering=2,
    params=[FloatRangeParameter('delta_gray', (0.0, 1.0, 0.01), 0.0)],
    tip="Range of gray values.")

cregisteredclass.Registration(
    'DeltaHSV', ColorDifferencePtr, DeltaHSV, ordering=3,
    params=[
    FloatRangeParameter('delta_hue', (0.0, 360.0, 1.0), 0.0),
    FloatRangeParameter('delta_saturation',
                       (0.0, 1.0, 0.01), 0.0),
    FloatRangeParameter('delta_value',
                       (0.0, 1.0, 0.01), 0.0)],
    tip="Range of colors in hue, saturation, and value space.")
