// -*- C++ -*-
// $RCSfile: coord.C,v $
// $Revision: 1.6 $
// $Author: reida $
// $Date: 2003/04/02 14:51:36 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>
#include "coord.h"
using namespace std;


Coord &Coord::operator+=(const ICoord &ic) {
  x[0] += ic(0);
  x[1] += ic(1);
  return *this;
}

Coord &Coord::operator-=(const ICoord &ic) {
  x[0] -= ic(0);
  x[1] -= ic(1);
  return *this;
}

ostream &operator<<(ostream &os, const Coord &coord) {
  os << "(" << coord(0) << ", " << coord(1) << ")";
  return os;
}

istream &operator>>(istream &is, Coord &coord) {
  char c;
  is >> c;
  if(!is || c != '(') {		// check for initial '('
    is.clear(ios::badbit | is.rdstate());
    return is;
  }
  is >> coord(0);		// read x component
  if(!is) return is;		// check for error
  is >> c;
  if(!is || c != ',') {		// check for ','
    is.clear(ios::badbit | is.rdstate());
    return is;
  }
  is >> coord(1);
  if(!is) return is;
  is >> c;
  if(!is || c != ')') {
    is.clear(ios::badbit | is.rdstate());
    return is;
  }
  return is;
}

//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//

ostream &operator<<(ostream &os, const ICoord &coord) {
  os << "(" << coord(0) << ", " << coord(1) << ")";
  return os;
}

istream &operator>>(istream &is, ICoord &coord) {
  char c;
  is >> c;
  if(!is || c != '(') {		// check for initial '('
    is.clear(ios::badbit | is.rdstate());
    return is;
  }
  is >> coord(0);		// read x component
  if(!is) return is;		// check for error
  is >> c;
  if(!is || c != ',') {		// check for ','
    is.clear(ios::badbit | is.rdstate());
    return is;
  }
  is >> coord(1);
  if(!is) return is;
  is >> c;
  if(!is || c != ')') {
    is.clear(ios::badbit | is.rdstate());
    return is;
  }
  return is;
}

bool operator<(const ICoord &a, const ICoord &b) {
  if(a(0) < b(0)) return true;
  if(a(0) > b(0)) return false;
  if(a(1) < b(1)) return true;
  return false;
}
