// -*- C++ -*-
// $RCSfile: trace.C,v $
// $Revision: 1.4 $
// $Author: reida $
// $Date: 2003/04/02 14:51:46 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#include "trace.h"

#include <iostream>
using namespace std;

// The static data has to live outside the #ifdef DEBUG, because to
// keep swig and python happy, the Trace_t class is defined even if
// it's used.  The Trace_t class is never instantiated if DEBUG is not
// defined.


int Trace_t::depth = 0;
bool Trace_t::enabled = true;

#ifdef DEBUG

// Called by the macro Trace(str).

Trace_t::Trace_t(const string &str) {
  if(enabled) {
    cerr << "==";
    for(int i=0; i<depth; i++)
      cerr << "==";
    cerr << " " << str << " {" << endl;
    cerr.flush();
  }
  ++depth;
}

Trace_t::~Trace_t() {
  --depth;
  if(enabled) {
    cerr << "==";
    for(int i=0; i<depth; i++)
      cerr << "==";
    cerr << " }" << endl;
    cerr.flush();
  }
}

#endif














