# -*- python -*-
# $RCSfile: bdymodparamwidget.py,v $
# $Revision: 1.2 $
# $Author: reida $
# $Date: 2004/06/22 15:41:02 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Special widget for boundary modifier parameters -- has some
# intelligence to know whether its result should be a
# PointBoundaryModifier or an EdgeBoundaryModifier.

from common.IO.GUI import regclassfactory
from engine import boundarymodifier

class BoundaryModParamWidget(regclassfactory.RegisteredClassFactory):
    def __init__(self, param, registry, obj=None, title=None,
                 callback=None, fill=0, expand=0, scope=None,
                 *args, **kwargs):
        self.parameter = param
        regclassfactory.RegisteredClassFactory.__init__(
            self, registry, obj=obj, title=title, callback=callback,
            fill=fill, expand=expand, scope=scope, *args, **kwargs)

    def includeRegistration(self, registration):
        return registration.modifiertype == self.parameter.modifiertype


def _makeBMPWidget(self, scope):
    return BoundaryModParamWidget(self, self.registry,
                                  self.value, scope=scope)

boundarymodifier.BoundaryModifierParameter.makeWidget = _makeBMPWidget
